//31/08/2017
//modificado por xsetaseta@gmail.com
//Juan Galaz
// Basado en http://www.instructables.com/id/Arduino-Processing-HMC5983-GY-282-Arduino-Proccesi/


#include <Wire.h>
 
#define BRUJULA 0x1E //I2C 7bit address of HMC5983


float heading, headingDegrees, headingFiltered, declination;
float Xm,Ym,Zm;
int mX_out,mY_out,mZ_out;

int  tiempo;
 
void setup()
{
  Serial.begin(9600);
  Serial.println("__Reseteando__");
  Wire.begin();
  
  delay(500);
  Wire.beginTransmission(BRUJULA); 
  Wire.write(0x02); // Select mode register
  Wire.write(0x00); // Continuous measurement mode
  Wire.endTransmission();
}


void loop()
{ 
  tiempo--;
  if(tiempo<0)
    {
      tiempo=10;
      Serial.print("Grados1="); Serial.println(gradosComplejo());
      Serial.print("Grados2="); Serial.println(gradosSimple());
    } 
  delay(5);
}




int gradosSimple(void)
{
  int grados;
  leerDatos();
  Xm = mX_out*0.00092; // Gauss unit  
  Ym = mY_out*0.00092;
 
  heading = atan2(Ym, Xm);
   // Corregir si  angulo es invertido
  if(heading <0){ heading += 2*PI; }  //ocurre entre 180º y 360º
  if(heading > 2*PI) {heading -= 2*PI;}
  
  headingDegrees = heading * 180/PI; // Para convertir radianes a grados
  grados=headingDegrees;
  return(grados);
}


int gradosComplejo(void)
{
  int grados;
  leerDatos();
  Xm = mX_out*0.00092; // Gauss unit  
  Ym = mY_out*0.00092;
  // ==============================
  //Calculating Heading
  heading = atan2(Ym, Xm);
 
  // Coreccion de la declinacin dependiendo de tu lugar
  // http://www.ngdc.noaa.gov/geomag-web/
  // Mi lugar //España  --- Palencia
  //En mi caso varia 1º
  declination = 0.020; 
  heading += declination;
  // Corregir si  angulo es invertido
  if(heading <0){ heading += 2*PI; }  //ocurre entre 180º y 360º
  if(heading > 2*PI) {heading -= 2*PI; Serial.print("***"); }
  
  headingDegrees = heading * 180/PI; // Para convertir radianes a grados
 //Si se quiere introducir un pequeño filtro para que no vibre el angulo 
 //  descomentar al linea siguiente
  headingFiltered = headingFiltered*0.85 + headingDegrees*0.15;
 // headingFiltered = headingDegrees;
  
  grados=headingFiltered;
  return(grados);
}

//Lectura registros  X,Z,Y
void leerDatos()
{ 
   Wire.beginTransmission(BRUJULA);
   Wire.write(0x03); //
   Wire.endTransmission();
   Wire.requestFrom(BRUJULA,6);
   mX_out= Wire.read()<<8 | Wire.read();
   mZ_out= Wire.read()<<8 | Wire.read();
   mY_out= Wire.read()<<8 | Wire.read();
}  

